<?php
/*
 * Copyright (c) 2017-2018 Aimy Extensions, Netzum Sorglos Software GmbH
 * Copyright (c) 2013-2017 Aimy Extensions, Lingua-Systems Software GmbH
 *
 * https://www.aimy-extensions.com/
 *
 * License: GNU GPLv2, see LICENSE.txt within distribution and/or
 *          http://www.aimy-extensions.com/software-license.html
 */
 defined( '_JEXEC' ) or die(); jimport( 'joomla.plugin.plugin' ); class plgSystemAimyCanonical extends JPlugin { function onBeforeCompileHead() { $sef_on = self::get_joomla_config( 'sef', false ); $domain = $this->params->get( 'domain', isset( $_SERVER[ 'HTTP_HOST' ] ) ? $_SERVER[ 'HTTP_HOST' ] : '' ); $proto = $this->params->get( 'protocol', null ); if ( empty( $domain ) ) { return; } $app = JFactory::getApplication(); $doc = JFactory::getDocument(); if ( $app->getName() != 'site' or $doc->getType() != 'html' ) { return; } $c_url = null; foreach ( $doc->_links as $url => $attr ) { if ( $attr[ 'relation' ] === 'canonical' ) { $c_url = $url; unset( $doc->_links[ $url ] ); } } $uri = JURI::getInstance( $c_url ? $c_url : 'SERVER' ); $uri->setHost( self::fix_domain_input( $domain ) ); if ( ! empty( $proto ) ) { $uri->setScheme( $proto ); } if ( strpos( $uri->getPath(), '/' ) !== 0 ) { $uri->setPath( '/' . $uri->getPath() ); } if ( $this->params->get( 'remove_query_string', false ) && $uri->getQuery() !== '' && $sef_on ) { $uri->setQuery( '' ); } $doc->addCustomTag( sprintf( '<link rel="canonical" href="%s" />', htmlspecialchars( $uri->toString(), ENT_COMPAT, 'UTF-8', false ) ) ); } static private function fix_domain_input( $domain ) { return preg_replace( '/\/.*$/', '', preg_replace( '/^[^\/]*?:\/\/+/', '', trim( $domain ) ) ); } static private function get_joomla_config( $key, $dflt = null ) { $app = JFactory::getApplication(); if ( version_compare( JVERSION, '3.3.0', '<' ) ) { return $app->getCfg( $key, $dflt ); } else { return $app->get( $key, $dflt ); } } } 
